import numpy
from typing import ClassVar, overload

ALL_FRAMES: DecodeMode
ALREADY_STARTED: TaskExecInfo
ALREADY_STOPPED: TaskExecInfo
ASYNC_ENCODE_SUPPORT: NV_ENC_CAPS
AV1: CudaVideoCodec
BGR: PixelFormat
BGR_32F: PixelFormat
BIT_DEPTH_NOT_SUPPORTED: TaskExecInfo
BT_601: ColorSpace
BT_709: ColorSpace
CONCEALED: TaskExecInfo
DEBUG: FFMpegLogLevel
DYNAMIC_QUERY_ENCODER_CAPACITY: NV_ENC_CAPS
END_OF_STREAM: TaskExecInfo
ERROR: FFMpegLogLevel
EXACT_FRAME: SeekMode
EXPOSED_COUNT: NV_ENC_CAPS
FAIL: TaskExecInfo
FATAL: FFMpegLogLevel
H264: CudaVideoCodec
HEIGHT_MAX: NV_ENC_CAPS
HEIGHT_MIN: NV_ENC_CAPS
HEVC: CudaVideoCodec
INFO: FFMpegLogLevel
JPEG: ColorRange
KEY_FRAMES: DecodeMode
LEVEL_MAX: NV_ENC_CAPS
LEVEL_MIN: NV_ENC_CAPS
MB_NUM_MAX: NV_ENC_CAPS
MB_PER_SEC_MAX: NV_ENC_CAPS
MJPEG: CudaVideoCodec
MORE_DATA_NEEDED: TaskExecInfo
MPEG: ColorRange
MPEG1: CudaVideoCodec
MPEG2: CudaVideoCodec
MPEG4: CudaVideoCodec
NOT_SUPPORTED: TaskExecInfo
NO_OUTPUT: TaskExecInfo
NO_PTS: int
NUM_MAX_BFRAMES: NV_ENC_CAPS
NUM_MAX_LTR_FRAMES: NV_ENC_CAPS
NUM_MAX_TEMPORAL_LAYERS: NV_ENC_CAPS
NV12: PixelFormat
P10: PixelFormat
P12: PixelFormat
PANIC: FFMpegLogLevel
PREPROC_SUPPORT: NV_ENC_CAPS
PREV_KEY_FRAME: SeekMode
RES_CHANGE: TaskExecInfo
RGB: PixelFormat
RGB_32F: PixelFormat
RGB_32F_PLANAR: PixelFormat
RGB_PLANAR: PixelFormat
SEPARATE_COLOUR_PLANE: NV_ENC_CAPS
SRC_DST_FMT_MISMATCH: TaskExecInfo
SUCCESS: TaskExecInfo
SUPPORTED_RATECONTROL_MODES: NV_ENC_CAPS
SUPPORT_10BIT_ENCODE: NV_ENC_CAPS
SUPPORT_ADAPTIVE_TRANSFORM: NV_ENC_CAPS
SUPPORT_ALPHA_LAYER_ENCODING: NV_ENC_CAPS
SUPPORT_BDIRECT_MODE: NV_ENC_CAPS
SUPPORT_BFRAME_REF_MODE: NV_ENC_CAPS
SUPPORT_CABAC: NV_ENC_CAPS
SUPPORT_CONSTRAINED_ENCODING: NV_ENC_CAPS
SUPPORT_CUSTOM_VBV_BUF_SIZE: NV_ENC_CAPS
SUPPORT_DYNAMIC_SLICE_MODE: NV_ENC_CAPS
SUPPORT_DYN_BITRATE_CHANGE: NV_ENC_CAPS
SUPPORT_DYN_FORCE_CONSTQP: NV_ENC_CAPS
SUPPORT_DYN_RCMODE_CHANGE: NV_ENC_CAPS
SUPPORT_DYN_RES_CHANGE: NV_ENC_CAPS
SUPPORT_EMPHASIS_LEVEL_MAP: NV_ENC_CAPS
SUPPORT_FIELD_ENCODING: NV_ENC_CAPS
SUPPORT_FMO: NV_ENC_CAPS
SUPPORT_HIERARCHICAL_BFRAMES: NV_ENC_CAPS
SUPPORT_HIERARCHICAL_PFRAMES: NV_ENC_CAPS
SUPPORT_INTRA_REFRESH: NV_ENC_CAPS
SUPPORT_LOOKAHEAD: NV_ENC_CAPS
SUPPORT_LOSSLESS_ENCODE: NV_ENC_CAPS
SUPPORT_MEONLY_MODE: NV_ENC_CAPS
SUPPORT_MONOCHROME: NV_ENC_CAPS
SUPPORT_MULTIPLE_REF_FRAMES: NV_ENC_CAPS
SUPPORT_QPELMV: NV_ENC_CAPS
SUPPORT_REF_PIC_INVALIDATION: NV_ENC_CAPS
SUPPORT_SAO: NV_ENC_CAPS
SUPPORT_STEREO_MVC: NV_ENC_CAPS
SUPPORT_SUBFRAME_READBACK: NV_ENC_CAPS
SUPPORT_TEMPORAL_AQ: NV_ENC_CAPS
SUPPORT_TEMPORAL_SVC: NV_ENC_CAPS
SUPPORT_WEIGHTED_PREDICTION: NV_ENC_CAPS
SUPPORT_YUV444_ENCODE: NV_ENC_CAPS
TIMEOUT: TaskExecInfo
UDEF: ColorRange
UNDEFINED: PixelFormat
UNSPEC: ColorSpace
VC1: CudaVideoCodec
VERBOSE: FFMpegLogLevel
VP9: CudaVideoCodec
WARNING: FFMpegLogLevel
WIDTH_MAX: NV_ENC_CAPS
WIDTH_MIN: NV_ENC_CAPS
Y: PixelFormat
YCBCR: PixelFormat
YUV420: PixelFormat
YUV420_10bit: PixelFormat
YUV422: PixelFormat
YUV444: PixelFormat
YUV444_10bit: PixelFormat

class ColorRange:
    __members__: ClassVar[dict] = ...  # read-only
    JPEG: ClassVar[ColorRange] = ...
    MPEG: ClassVar[ColorRange] = ...
    UDEF: ClassVar[ColorRange] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ColorSpace:
    __members__: ClassVar[dict] = ...  # read-only
    BT_601: ClassVar[ColorSpace] = ...
    BT_709: ClassVar[ColorSpace] = ...
    UNSPEC: ClassVar[ColorSpace] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ColorspaceConversionContext:
    color_range: ColorRange
    color_space: ColorSpace
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, color_space: ColorSpace, color_range: ColorRange) -> None: ...

class CudaBuffer:
    def __init__(self, *args, **kwargs) -> None: ...
    def Clone(self) -> CudaBuffer: ...
    @overload
    def CopyFrom(self, other: CudaBuffer, context: int, stream: int) -> None: ...
    @overload
    def CopyFrom(self, other: CudaBuffer, gpu_id: int) -> None: ...
    def GetElemSize(self) -> int: ...
    def GetNumElems(self) -> int: ...
    def GetRawMemSize(self) -> int: ...
    def GpuMem(self) -> int: ...
    @staticmethod
    def Make(elem_size: int, num_elems: int, gpu_id: int) -> CudaBuffer: ...

class CudaStreamEvent:
    def __init__(self, cuda_stream: int, gpu_id: int = ...) -> None: ...
    def Record(self) -> None: ...
    def Wait(self) -> None: ...

class CudaVideoCodec:
    __members__: ClassVar[dict] = ...  # read-only
    AV1: ClassVar[CudaVideoCodec] = ...
    H264: ClassVar[CudaVideoCodec] = ...
    HEVC: ClassVar[CudaVideoCodec] = ...
    MJPEG: ClassVar[CudaVideoCodec] = ...
    MPEG1: ClassVar[CudaVideoCodec] = ...
    MPEG2: ClassVar[CudaVideoCodec] = ...
    MPEG4: ClassVar[CudaVideoCodec] = ...
    VC1: ClassVar[CudaVideoCodec] = ...
    VP9: ClassVar[CudaVideoCodec] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class CuvidParserException(Exception): ...

class DecodeMode:
    __members__: ClassVar[dict] = ...  # read-only
    ALL_FRAMES: ClassVar[DecodeMode] = ...
    KEY_FRAMES: ClassVar[DecodeMode] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class FFMpegLogLevel:
    __members__: ClassVar[dict] = ...  # read-only
    DEBUG: ClassVar[FFMpegLogLevel] = ...
    ERROR: ClassVar[FFMpegLogLevel] = ...
    FATAL: ClassVar[FFMpegLogLevel] = ...
    INFO: ClassVar[FFMpegLogLevel] = ...
    PANIC: ClassVar[FFMpegLogLevel] = ...
    VERBOSE: ClassVar[FFMpegLogLevel] = ...
    WARNING: ClassVar[FFMpegLogLevel] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class HwResetException(Exception): ...

class MotionVector:
    def __init__(self, *args, **kwargs) -> None: ...

class NV_ENC_CAPS:
    __members__: ClassVar[dict] = ...  # read-only
    ASYNC_ENCODE_SUPPORT: ClassVar[NV_ENC_CAPS] = ...
    DYNAMIC_QUERY_ENCODER_CAPACITY: ClassVar[NV_ENC_CAPS] = ...
    EXPOSED_COUNT: ClassVar[NV_ENC_CAPS] = ...
    HEIGHT_MAX: ClassVar[NV_ENC_CAPS] = ...
    HEIGHT_MIN: ClassVar[NV_ENC_CAPS] = ...
    LEVEL_MAX: ClassVar[NV_ENC_CAPS] = ...
    LEVEL_MIN: ClassVar[NV_ENC_CAPS] = ...
    MB_NUM_MAX: ClassVar[NV_ENC_CAPS] = ...
    MB_PER_SEC_MAX: ClassVar[NV_ENC_CAPS] = ...
    NUM_MAX_BFRAMES: ClassVar[NV_ENC_CAPS] = ...
    NUM_MAX_LTR_FRAMES: ClassVar[NV_ENC_CAPS] = ...
    NUM_MAX_TEMPORAL_LAYERS: ClassVar[NV_ENC_CAPS] = ...
    PREPROC_SUPPORT: ClassVar[NV_ENC_CAPS] = ...
    SEPARATE_COLOUR_PLANE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORTED_RATECONTROL_MODES: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_10BIT_ENCODE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_ADAPTIVE_TRANSFORM: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_ALPHA_LAYER_ENCODING: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_BDIRECT_MODE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_BFRAME_REF_MODE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_CABAC: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_CONSTRAINED_ENCODING: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_CUSTOM_VBV_BUF_SIZE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_DYNAMIC_SLICE_MODE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_DYN_BITRATE_CHANGE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_DYN_FORCE_CONSTQP: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_DYN_RCMODE_CHANGE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_DYN_RES_CHANGE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_EMPHASIS_LEVEL_MAP: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_FIELD_ENCODING: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_FMO: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_HIERARCHICAL_BFRAMES: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_HIERARCHICAL_PFRAMES: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_INTRA_REFRESH: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_LOOKAHEAD: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_LOSSLESS_ENCODE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_MEONLY_MODE: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_MONOCHROME: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_MULTIPLE_REF_FRAMES: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_QPELMV: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_REF_PIC_INVALIDATION: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_SAO: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_STEREO_MVC: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_SUBFRAME_READBACK: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_TEMPORAL_AQ: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_TEMPORAL_SVC: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_WEIGHTED_PREDICTION: ClassVar[NV_ENC_CAPS] = ...
    SUPPORT_YUV444_ENCODE: ClassVar[NV_ENC_CAPS] = ...
    WIDTH_MAX: ClassVar[NV_ENC_CAPS] = ...
    WIDTH_MIN: ClassVar[NV_ENC_CAPS] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class PacketData:
    bsl: int
    dts: int
    duration: int
    key: int
    ntp_sec: float
    pos: int
    pts: int
    pts_sec: float
    def __init__(self) -> None: ...

class PixelFormat:
    __members__: ClassVar[dict] = ...  # read-only
    BGR: ClassVar[PixelFormat] = ...
    BGR_32F: ClassVar[PixelFormat] = ...
    NV12: ClassVar[PixelFormat] = ...
    P10: ClassVar[PixelFormat] = ...
    P12: ClassVar[PixelFormat] = ...
    RGB: ClassVar[PixelFormat] = ...
    RGB_32F: ClassVar[PixelFormat] = ...
    RGB_32F_PLANAR: ClassVar[PixelFormat] = ...
    RGB_PLANAR: ClassVar[PixelFormat] = ...
    UNDEFINED: ClassVar[PixelFormat] = ...
    Y: ClassVar[PixelFormat] = ...
    YCBCR: ClassVar[PixelFormat] = ...
    YUV420: ClassVar[PixelFormat] = ...
    YUV420_10bit: ClassVar[PixelFormat] = ...
    YUV422: ClassVar[PixelFormat] = ...
    YUV444: ClassVar[PixelFormat] = ...
    YUV444_10bit: ClassVar[PixelFormat] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class PyBufferUploader:
    @overload
    def __init__(self, elem_size: int, num_elems: int, gpu_id: int) -> None: ...
    @overload
    def __init__(self, elem_size: int, num_elems: int, context: int, stream: int) -> None: ...
    def UploadSingleBuffer(self, array: numpy.ndarray[numpy.uint8]) -> CudaBuffer: ...

class PyCudaBufferDownloader:
    @overload
    def __init__(self, elem_size: int, num_elems: int, gpu_id: int) -> None: ...
    @overload
    def __init__(self, elem_size: int, num_elems: int, context: int, stream: int) -> None: ...
    def DownloadSingleCudaBuffer(self, buffer: CudaBuffer, array: numpy.ndarray[numpy.uint8]) -> bool: ...

class PyDecoder:
    def __init__(self, input: str, opts: dict[str, str], gpu_id: int = ...) -> None: ...
    def Accelerated(self) -> bool: ...
    def AvgFramerate(self) -> float: ...
    def Bitrate(self) -> int: ...
    def ColorRange(self) -> ColorRange: ...
    def ColorSpace(self) -> ColorSpace: ...
    @overload
    def DecodeSingleFrame(self, frame: numpy.ndarray, seek_ctx: SeekContext | None = ...) -> tuple[bool, TaskExecInfo]: ...
    @overload
    def DecodeSingleFrame(self, frame: numpy.ndarray, pkt_data: PacketData, seek_ctx: SeekContext | None = ...) -> tuple[bool, TaskExecInfo]: ...
    @overload
    def DecodeSingleSurface(self, surf: Surface, seek_ctx: SeekContext | None = ...) -> tuple[bool, TaskExecInfo]: ...
    @overload
    def DecodeSingleSurface(self, surf: Surface, pkt_data: PacketData, seek_ctx: SeekContext | None = ...) -> tuple[bool, TaskExecInfo]: ...
    @overload
    def DecodeSingleSurfaceAsync(self, surf: Surface, seek_ctx: SeekContext | None = ...) -> tuple[bool, TaskExecInfo]: ...
    @overload
    def DecodeSingleSurfaceAsync(self, surf: Surface, pkt_data: PacketData, seek_ctx: SeekContext | None = ...) -> tuple[bool, TaskExecInfo]: ...
    def Delay(self) -> int: ...
    def DisplayRotation(self) -> float: ...
    def Duration(self) -> float: ...
    def Format(self) -> PixelFormat: ...
    def Framerate(self) -> float: ...
    def GetMotionVectors(self) -> list[MotionVector]: ...
    def GopSize(self) -> int: ...
    def GuessFramerate(self) -> float: ...
    def Height(self) -> int: ...
    def HostFrameSize(self) -> int: ...
    def Level(self) -> int: ...
    def Metadata(self) -> dict[str, dict[str, str]]: ...
    def Mode(self) -> DecodeMode: ...
    def NumFrames(self) -> int: ...
    def NumStreams(self) -> int: ...
    @staticmethod
    def Probe(input: str) -> list[StreamParams]: ...
    def Profile(self) -> int: ...
    def SetMode(self, arg0: DecodeMode) -> None: ...
    def StartTime(self) -> float | None: ...
    def StreamIndex(self) -> int: ...
    def Timebase(self) -> float: ...
    def VFR(self) -> bool: ...
    def Width(self) -> int: ...
    @property
    def Stream(self) -> int: ...

class PyFrameConverter:
    def __init__(self, width: int, height: int, src_format: PixelFormat, dst_format: PixelFormat) -> None: ...
    @overload
    def Execute(self, src: numpy.ndarray[numpy.uint8], dst: numpy.ndarray[numpy.uint8], cc_ctx: ColorspaceConversionContext) -> bool: ...
    @overload
    def Execute(self, src: numpy.ndarray[numpy.uint8], dst: numpy.ndarray[numpy.float32], cc_ctx: ColorspaceConversionContext) -> bool: ...
    @overload
    def Execute(self, src: numpy.ndarray[numpy.float32], dst: numpy.ndarray[numpy.uint8], cc_ctx: ColorspaceConversionContext) -> bool: ...
    @overload
    def Execute(self, src: numpy.ndarray[numpy.float32], dst: numpy.ndarray[numpy.float32], cc_ctx: ColorspaceConversionContext) -> bool: ...
    def Format(self) -> PixelFormat: ...

class PyFrameUploader:
    @overload
    def __init__(self, width: int, height: int, format: PixelFormat, gpu_id: int) -> None: ...
    @overload
    def __init__(self, width: int, height: int, format: PixelFormat, context: int, stream: int) -> None: ...
    def Format(self) -> PixelFormat: ...
    def UploadSingleFrame(self, *args, **kwargs): ...

class PyNvEncoder:
    @overload
    def __init__(self, settings: dict[str, str], gpu_id: int, format: PixelFormat = ..., verbose: bool = ...) -> None: ...
    @overload
    def __init__(self, settings: dict[str, str], context: int, stream: int, format: PixelFormat = ..., verbose: bool = ...) -> None: ...
    def Capabilities(self) -> dict[NV_ENC_CAPS, int]: ...
    @overload
    def EncodeSingleFrame(self, frame: numpy.ndarray[numpy.uint8], packet: numpy.ndarray[numpy.uint8], sei: numpy.ndarray[numpy.uint8], sync: bool, append: bool) -> bool: ...
    @overload
    def EncodeSingleFrame(self, frame: numpy.ndarray[numpy.uint8], packet: numpy.ndarray[numpy.uint8], sei: numpy.ndarray[numpy.uint8], sync: bool) -> bool: ...
    @overload
    def EncodeSingleFrame(self, frame: numpy.ndarray[numpy.uint8], packet: numpy.ndarray[numpy.uint8], sync: bool) -> bool: ...
    @overload
    def EncodeSingleFrame(self, frame: numpy.ndarray[numpy.uint8], packet: numpy.ndarray[numpy.uint8], sei: numpy.ndarray[numpy.uint8]) -> bool: ...
    @overload
    def EncodeSingleFrame(self, frame: numpy.ndarray[numpy.uint8], packet: numpy.ndarray[numpy.uint8]) -> bool: ...
    @overload
    def EncodeSingleSurface(self, nvcvimage: object, packet: numpy.ndarray[numpy.uint8], testbool: bool) -> bool: ...
    @overload
    def EncodeSingleSurface(self, surface, packet: numpy.ndarray[numpy.uint8], sei: numpy.ndarray[numpy.uint8], sync: bool, append: bool) -> bool: ...
    @overload
    def EncodeSingleSurface(self, surface, packet: numpy.ndarray[numpy.uint8], sei: numpy.ndarray[numpy.uint8], sync: bool) -> bool: ...
    @overload
    def EncodeSingleSurface(self, surface, packet: numpy.ndarray[numpy.uint8], sync: bool) -> bool: ...
    @overload
    def EncodeSingleSurface(self, surface, packet: numpy.ndarray[numpy.uint8], sei: numpy.ndarray[numpy.uint8]) -> bool: ...
    @overload
    def EncodeSingleSurface(self, surface, packet: numpy.ndarray[numpy.uint8]) -> bool: ...
    def Flush(self, packets: numpy.ndarray[numpy.uint8]) -> bool: ...
    def FlushSinglePacket(self, packets: numpy.ndarray[numpy.uint8]) -> bool: ...
    def Format(self) -> PixelFormat: ...
    def GetFrameSizeInBytes(self) -> int: ...
    def Height(self) -> int: ...
    def Reconfigure(self, settings: dict[str, str], force_idr: bool = ..., reset_encoder: bool = ..., verbose: bool = ...) -> bool: ...
    def Width(self) -> int: ...

class PyNvJpegEncoder:
    def __init__(self, asyncio_loop: object, gpu_id: int) -> None: ...
    def Compress(self, surfaces: list, context: PyNvJpegEncoderContext) -> tuple: ...
    def CompressAsync(self, surfaces: list, context: PyNvJpegEncoderContext) -> object: ...
    def Context(self, compression: int, pixel_format: PixelFormat) -> PyNvJpegEncoderContext: ...

class PyNvJpegEncoderContext:
    def __init__(self, *args, **kwargs) -> None: ...
    def Compression(self) -> int: ...
    def Format(self) -> PixelFormat: ...

class PySurfaceConverter:
    @overload
    def __init__(self, width: int, height: int, src_format: PixelFormat, dst_format: PixelFormat, gpu_id: int) -> None: ...
    @overload
    def __init__(self, width: int, height: int, src_format: PixelFormat, dst_format: PixelFormat, context: int, stream: int) -> None: ...
    def Execute(self, src, dst, cc_ctx: ColorspaceConversionContext | None = ...) -> bool: ...
    def ExecuteAsync(self, src, dst, cc_ctx: ColorspaceConversionContext | None = ...) -> bool: ...
    def Format(self) -> PixelFormat: ...

class PySurfaceDownloader:
    @overload
    def __init__(self, width: int, height: int, format: PixelFormat, gpu_id: int) -> None: ...
    @overload
    def __init__(self, width: int, height: int, format: PixelFormat, context: int, stream: int) -> None: ...
    @overload
    def DownloadSingleSurface(self, surface, frame: numpy.ndarray[numpy.uint8]) -> bool: ...
    @overload
    def DownloadSingleSurface(self, surface, frame: numpy.ndarray[numpy.float32]) -> bool: ...
    @overload
    def DownloadSingleSurface(self, surface, frame: numpy.ndarray[numpy.uint16]) -> bool: ...
    @overload
    def DownloadSingleSurfaceAsync(self, surface, frame: numpy.ndarray[numpy.uint8]) -> bool: ...
    @overload
    def DownloadSingleSurfaceAsync(self, surface, frame: numpy.ndarray[numpy.float32]) -> bool: ...
    @overload
    def DownloadSingleSurfaceAsync(self, surface, frame: numpy.ndarray[numpy.uint16]) -> bool: ...
    def Format(self) -> PixelFormat: ...
    @property
    def Stream(self) -> int: ...

class PySurfaceRemaper:
    @overload
    def __init__(self, x_map: numpy.ndarray[numpy.float32], y_map: numpy.ndarray[numpy.float32], format: PixelFormat, gpu_id: int) -> None: ...
    @overload
    def __init__(self, x_map: numpy.ndarray[numpy.float32], y_map: numpy.ndarray[numpy.float32], format: PixelFormat, context: int, stream: int) -> None: ...
    def Execute(self, *args, **kwargs): ...
    def Format(self) -> PixelFormat: ...

class PySurfaceResizer:
    @overload
    def __init__(self, width: int, height: int, format: PixelFormat, gpu_id: int) -> None: ...
    @overload
    def __init__(self, width: int, height: int, format: PixelFormat, context: int, stream: int) -> None: ...
    def Execute(self, *args, **kwargs): ...
    def ExecuteAsync(self, src, dst) -> bool: ...
    def Format(self) -> PixelFormat: ...

class PySurfaceRotator:
    @overload
    def __init__(self, gpu_id: int) -> None: ...
    @overload
    def __init__(self, gpu_id: int, stream: int) -> None: ...
    def Run(self, src: Surface, dst: Surface, angle: float, shift_x: float = ..., shift_y: float = ...) -> tuple[bool, TaskExecInfo]: ...
    def RunAsync(self, src: Surface, dst: Surface, angle: float, shift_x: float = ..., shift_y: float = ...) -> tuple[bool, TaskExecInfo]: ...
    @property
    def SupportedFormats(self) -> list[PixelFormat]: ...

class SeekContext:
    mode: SeekMode
    out_frame_pts: int
    seek_frame: int
    seek_tssec: float
    @overload
    def __init__(self, seek_frame: int) -> None: ...
    @overload
    def __init__(self, seek_frame: int, mode: SeekMode) -> None: ...
    @overload
    def __init__(self, seek_ts: float) -> None: ...
    @overload
    def __init__(self, seek_ts: float, mode: SeekMode) -> None: ...
    @property
    def num_frames_decoded(self) -> int: ...

class SeekMode:
    __members__: ClassVar[dict] = ...  # read-only
    EXACT_FRAME: ClassVar[SeekMode] = ...
    PREV_KEY_FRAME: ClassVar[SeekMode] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class StreamParams:
    avg_fps: float
    bit_rate: int
    codec_id: int
    color_range: ColorRange
    color_space: ColorSpace
    duration_sec: float
    fourcc: int
    fps: float
    guess_fps: float
    height: int
    level: int
    num_frames: int
    profile: int
    start_time: int
    start_time_sec: float
    time_base: float
    width: int
    def __init__(self) -> None: ...

class Surface:
    def __init__(self, *args, **kwargs) -> None: ...
    @overload
    def Clone(self) -> Surface: ...
    @overload
    def Clone(self, gpu_id: int) -> Surface: ...
    @overload
    def Clone(self, context: int, stream: int) -> Surface: ...
    @overload
    def CopyFrom(self, other: Surface, gpu_id: int) -> None: ...
    @overload
    def CopyFrom(self, other: Surface, context: int, stream: int) -> None: ...
    @overload
    def Crop(self, x: int, y: int, w: int, h: int, gpu_id: int) -> Surface: ...
    @overload
    def Crop(self, x: int, y: int, w: int, h: int, context: int, stream: int) -> Surface: ...
    def Empty(self) -> bool: ...
    def Format(self) -> PixelFormat: ...
    def Height(self, plane: int = ...) -> int: ...
    def HostSize(self) -> int: ...
    @overload
    @staticmethod
    def Make(format: PixelFormat, width: int, height: int, gpu_id: int) -> Surface: ...
    @overload
    @staticmethod
    def Make(format: PixelFormat, width: int, height: int, context: int) -> Surface: ...
    def NumPlanes(self) -> int: ...
    def OwnMemory(self) -> bool: ...
    def Pitch(self, plane: int = ...) -> int: ...
    def PlanePtr(self, plane: int = ...) -> SurfacePlane: ...
    def Width(self, plane: int = ...) -> int: ...

class SurfacePlane:
    def __init__(self, *args, **kwargs) -> None: ...
    def ElemSize(self) -> int: ...
    @overload
    def Export(self, dst: int, dst_pitch: int, gpu_id: int) -> None: ...
    @overload
    def Export(self, dst: int, dst_pitch: int, context: int, stream: int) -> None: ...
    def GpuMem(self) -> int: ...
    def Height(self) -> int: ...
    def HostFrameSize(self) -> int: ...
    @overload
    def Import(self, src: int, src_pitch: int, gpu_id: int) -> None: ...
    @overload
    def Import(self, src: int, src_pitch: int, context: int, stream: int) -> None: ...
    def Pitch(self) -> int: ...
    def Width(self) -> int: ...

class TaskExecDetails:
    info: TaskExecInfo
    def __init__(self) -> None: ...

class TaskExecInfo:
    __members__: ClassVar[dict] = ...  # read-only
    ALREADY_STARTED: ClassVar[TaskExecInfo] = ...
    ALREADY_STOPPED: ClassVar[TaskExecInfo] = ...
    BIT_DEPTH_NOT_SUPPORTED: ClassVar[TaskExecInfo] = ...
    CONCEALED: ClassVar[TaskExecInfo] = ...
    END_OF_STREAM: ClassVar[TaskExecInfo] = ...
    FAIL: ClassVar[TaskExecInfo] = ...
    MORE_DATA_NEEDED: ClassVar[TaskExecInfo] = ...
    NOT_SUPPORTED: ClassVar[TaskExecInfo] = ...
    NO_OUTPUT: ClassVar[TaskExecInfo] = ...
    RES_CHANGE: ClassVar[TaskExecInfo] = ...
    SRC_DST_FMT_MISMATCH: ClassVar[TaskExecInfo] = ...
    SUCCESS: ClassVar[TaskExecInfo] = ...
    TIMEOUT: ClassVar[TaskExecInfo] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

def GetCudaContextAndStream(gpu_id: int) -> tuple[int, int]: ...
def GetCudaVersion() -> int: ...
def GetDefaultNetworkTimeout() -> int: ...
def GetNumGpus() -> int: ...
def GetNvencParams() -> dict[str, str]: ...
def IsProfilingAvailable() -> bool: ...
def SetDefaultNetworkTimeout(timeout: int) -> None: ...
def SetFFMpegLogLevel(arg0: FFMpegLogLevel) -> None: ...
def StartProfiling() -> TaskExecInfo: ...
def StopProfiling(profile_data: numpy.ndarray[numpy.uint8]) -> TaskExecInfo: ...
